routes/web.php
<?php

use App\Http\Controllers\AlbumController;
use App\Http\Controllers\GalleryController;
use App\Http\Controllers\GalleryImageController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::group(['middleware' => ['auth']], function() {
    Route::resource('albums', AlbumController::class);
    Route::resource('galleries', GalleryController::class);
    // Route::resource('galleries/{gallery}/galleryimages', GalleryImageController::class);
    Route::get('galleries/{gallery}/galleryimages', [GalleryImageController::class, 'index'])->name('galleryimages.index');
    Route::post('galleries/{gallery}/galleryimages', [GalleryImageController::class, 'store'])->name('galleryimages.store');
    Route::get('galleries/{gallery}/galleryimages/create', [GalleryImageController::class, 'create'])->name('galleryimages.create');
    Route::put('galleries/{gallery}/galleryimages/update', [GalleryImageController::class, 'update'])->name('galleryimages.update');
    Route::put('galleries/{gallery}/galleryimages/updatesortorder', [GalleryImageController::class, 'updateSortOrder'])->name('galleryimages.updatesortorder');
});

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Album.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Album extends Model
{
    use HasFactory;

    protected $fillable = ['name'];

    public function galleries()
    {
        return $this->hasMany(Gallery::class, 'album_id', 'id');
    }
}

app/Http/Controllers/AlbumController.php
<?php

namespace App\Http\Controllers;

use App\Models\Album;
use Illuminate\Http\Request;

class AlbumController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $albums = Album::all();

        $index = 0;

        return view('albums.index', compact('albums', 'index'));        
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('albums.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $albumData = $this->validate($request, [
            'name' => 'required'
        ]);

        Album::create($albumData);
        return redirect()->route('albums.index')
                         ->with('success', 'Album added successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Album  $album
     * @return \Illuminate\Http\Response
     */
    public function show(Album $album)
    {
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Album  $album
     * @return \Illuminate\Http\Response
     */
    public function edit(Album $album)
    {
        return view('albums.edit', compact('album'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Album  $album
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Album $album)
    {
        $albumData = $this->validate($request, [
            'name' => 'required'
        ]);

        $album->update($albumData);
        return redirect()->route('albums.index')
                         ->with('success', 'Album updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Album  $album
     * @return \Illuminate\Http\Response
     */
    public function destroy(Album $album)
    {
        if($album->galleries()->count() == 0) {
            $album->delete();
            return redirect()->route('albums.index')
                         ->with('success', 'Album deleted successfully');
        }
        return redirect()->route('albums.index')
                         ->with('error', 'Album is associated with a gallery!');
    }
}

resources/views/albums/create.blade.php
@extends('layouts.app')

@section('content')

<div class="row">
    <div class="col-lg-12 margin-tb">
        <div class="float-left">
            <h2>New Album</h2>
        </div>
        <div class="float-right">
            <a class="btn btn-primary" href="{{ route('albums.index') }}">Back</a>
        </div>
    </div>
</div>

@if(count($errors) > 0)
    <div class="alert alert-danger">
        <strong>Whoops!</strong> There were some problems with your input.<br><br>
        <ul>
            @foreach($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif

<form action="{{ route('albums.store') }}" method="POST">
    @csrf
    <div class="row">
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <div class="form-group">
                <strong>Album Name:</strong>
                <input type="text" name="name" id="name" placeholder="Album Name" class="form-control" value="{{ old('name') }}">
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <button type="submit" class="btn btn-primary">Save</button>
        </div>
    </div>
</form>

@endsection

resources/views/albums/edit.blade.php
@extends('layouts.app')

@section('content')

<div class="row">
    <div class="col-lg-12 margin-tb">
        <div class="float-left">
            <h2>Edit Album</h2>
        </div>
        <div class="float-right">
            <a class="btn btn-primary" href="{{ route('albums.index') }}">Back</a>
        </div>
    </div>
</div>

@if(count($errors) > 0)
    <div class="alert alert-danger">
        <strong>Whoops!</strong> There were some problems with your input.<br><br>
        <ul>
            @foreach($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif

<form action="{{ route('albums.update', $album->id) }}" method="POST">
    @csrf
    @method('PUT')
    <div class="row">
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <div class="form-group">
                <strong>Album Name:</strong>
                <input type="text" name="name" id="name" placeholder="Album Name" class="form-control" value="{{ $album->name }}">
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <button type="submit" class="btn btn-primary">Save</button>
        </div>
    </div>
</form>

@endsection

resources/views/albums/index.blade.php
@extends('layouts.app')

@section('header-css')
    <link rel="stylesheet" href="{{ asset('css/vendor/datatable/datatables.min.css') }}">
@endsection

@section('content')

<div class="row">
    <div class="col-lg-12 margin-tb">
        <div class="float-left">
            <h2>Albums</h2>
        </div>
        <div class="float-right mb-4">
            <a class="btn btn-success" href="{{ route('albums.create') }}">Create New Album</a>
        </div>
    </div>
</div>

@if($message = Session::get('success'))
    <div class="alert alert-success">
        <p>{{ $message }}</p>
    </div>
@endif

@if($message = Session::get('error'))
    <div class="alert alert-danger">
        <p>{{ $message }}</p>
    </div>
@endif

<table class="table table-striped table-bordered" id="datatable" style="width: 100%;">
    <thead>
        <tr>
            <th>No.</th>
            <th>Album</th>
            <th width="280px">Action</th>
        </tr>
    </thead>
    <tbody>
        @forelse($albums as $key => $album)
            <tr>
                <td>{{ ++$index }}</td>
                <td>{{ $album->name }}</td>
                <td>
                    <a class="btn btn-primary" href="{{ route('albums.edit', $album->id) }}">Edit</a>
                    <form method="POST" action="{{ route('albums.destroy', $album->id) }}" style="display:inline">
                        @csrf
                        @method('DELETE')
                        <input type="submit" value="Delete" class="btn btn-danger show_confirm">
                    </form>
                </td>
            </tr>
        @empty
            <tr>
                <td class="text-center" colspan="6">No Albums to list.</td>
            </tr>
        @endforelse
    </tbody>
</table>
@endsection

@section('footer-scripts')
    <script type="text/javascript" src="{{ asset('js/vendor/datatable/dataTables.min.js')}}"></script>
    <script type="text/javascript" src="{{ asset('js/vendor/datatable/dataTables.bootstrap4.min.js')}}"></script>
    <script type="text/javascript">
        jQuery('#datatable').DataTable();
    </script>
@endsection